/*
* React Tooltip
* {@link https://github.com/ReactTooltip/react-tooltip}
* @copyright ReactTooltip Team
* @license MIT
*/
import e,{createContext as t,useState as r,useCallback as o,useMemo as n,useContext as l,useRef as i,useEffect as c,useLayoutEffect as s}from"react";import{arrow as a,computePosition as d,offset as u,flip as p,shift as v,autoUpdate as m}from"@floating-ui/dom";import f from"classnames";const y="react-tooltip-core-styles",h="react-tooltip-base-styles",w={core:!1,base:!1};function b({css:e,id:t=h,type:r="base",ref:o}){var n,l;if(!e||"undefined"==typeof document||w[r])return;if("core"===r&&"undefined"!=typeof process&&(null===(n=null===process||void 0===process?void 0:process.env)||void 0===n?void 0:n.REACT_TOOLTIP_DISABLE_CORE_STYLES))return;if("base"!==r&&"undefined"!=typeof process&&(null===(l=null===process||void 0===process?void 0:process.env)||void 0===l?void 0:l.REACT_TOOLTIP_DISABLE_BASE_STYLES))return;"core"===r&&(t=y),o||(o={});const{insertAt:i}=o;if(document.getElementById(t))return void console.warn(`[react-tooltip] Element with id '${t}' already exists. Call \`removeStyle()\` first`);const c=document.head||document.getElementsByTagName("head")[0],s=document.createElement("style");s.id=t,s.type="text/css","top"===i&&c.firstChild?c.insertBefore(s,c.firstChild):c.appendChild(s),s.styleSheet?s.styleSheet.cssText=e:s.appendChild(document.createTextNode(e)),w[r]=!0}function S({type:e="base",id:t=h}={}){if(!w[e])return;"core"===e&&(t=y);const r=document.getElementById(t);"style"===(null==r?void 0:r.tagName)?null==r||r.remove():console.warn(`[react-tooltip] Failed to remove 'style' element with id '${t}'. Call \`injectStyle()\` first`),w[e]=!1}const E=(e,t,r)=>{let o=null;return function(...n){const l=()=>{o=null,r||e.apply(this,n)};r&&!o&&(e.apply(this,n),o=setTimeout(l,t)),r||(o&&clearTimeout(o),o=setTimeout(l,t))}},_="DEFAULT_TOOLTIP_ID",g={anchorRefs:new Set,activeAnchor:{current:null},attach:()=>{},detach:()=>{},setActiveAnchor:()=>{}},A=t({getTooltipData:()=>g}),T=({children:t})=>{const[l,i]=r({[_]:new Set}),[c,s]=r({[_]:{current:null}}),a=(e,...t)=>{i((r=>{var o;const n=null!==(o=r[e])&&void 0!==o?o:new Set;return t.forEach((e=>n.add(e))),{...r,[e]:new Set(n)}}))},d=(e,...t)=>{i((r=>{const o=r[e];return o?(t.forEach((e=>o.delete(e))),{...r}):r}))},u=o(((e=_)=>{var t,r;return{anchorRefs:null!==(t=l[e])&&void 0!==t?t:new Set,activeAnchor:null!==(r=c[e])&&void 0!==r?r:{current:null},attach:(...t)=>a(e,...t),detach:(...t)=>d(e,...t),setActiveAnchor:t=>((e,t)=>{s((r=>{var o;return(null===(o=r[e])||void 0===o?void 0:o.current)===t.current?r:{...r,[e]:t}}))})(e,t)}}),[l,c,a,d]),p=n((()=>({getTooltipData:u})),[u]);return e.createElement(A.Provider,{value:p},t)};function O(e=_){return l(A).getTooltipData(e)}const L=({tooltipId:t,children:r,className:o,place:n,content:l,html:s,variant:a,offset:d,wrapper:u,events:p,positionStrategy:v,delayShow:m,delayHide:y})=>{const{attach:h,detach:w}=O(t),b=i(null);return c((()=>(h(b),()=>{w(b)})),[]),e.createElement("span",{ref:b,className:f("react-tooltip-wrapper",o),"data-tooltip-place":n,"data-tooltip-content":l,"data-tooltip-html":s,"data-tooltip-variant":a,"data-tooltip-offset":d,"data-tooltip-wrapper":u,"data-tooltip-events":p,"data-tooltip-position-strategy":v,"data-tooltip-delay-show":m,"data-tooltip-delay-hide":y},r)},R="undefined"!=typeof window?s:c,C=e=>{if(!(e instanceof HTMLElement||e instanceof SVGElement))return!1;const t=getComputedStyle(e);return["overflow","overflow-x","overflow-y"].some((e=>{const r=t.getPropertyValue(e);return"auto"===r||"scroll"===r}))},N=e=>{if(!e)return null;let t=e.parentElement;for(;t;){if(C(t))return t;t=t.parentElement}return document.scrollingElement||document.documentElement},k=async({elementReference:e=null,tooltipReference:t=null,tooltipArrowReference:r=null,place:o="top",offset:n=10,strategy:l="absolute",middlewares:i=[u(Number(n)),p(),v({padding:5})],border:c})=>{if(!e)return{tooltipStyles:{},tooltipArrowStyles:{},place:o};if(null===t)return{tooltipStyles:{},tooltipArrowStyles:{},place:o};const s=i;return r?(s.push(a({element:r,padding:5})),d(e,t,{placement:o,strategy:l,middleware:s}).then((({x:e,y:t,placement:r,middlewareData:o})=>{var n,l;const i={left:`${e}px`,top:`${t}px`,border:c},{x:s,y:a}=null!==(n=o.arrow)&&void 0!==n?n:{x:0,y:0},d=null!==(l={top:"bottom",right:"left",bottom:"top",left:"right"}[r.split("-")[0]])&&void 0!==l?l:"bottom",u=c&&{borderBottom:c,borderRight:c};let p=0;if(c){const e=`${c}`.match(/(\d+)px/);p=(null==e?void 0:e[1])?Number(e[1]):1}return{tooltipStyles:i,tooltipArrowStyles:{left:null!=s?`${s}px`:"",top:null!=a?`${a}px`:"",right:"",bottom:"",...u,[d]:`-${4+p}px`},place:r}}))):d(e,t,{placement:"bottom",strategy:l,middleware:s}).then((({x:e,y:t,placement:r})=>({tooltipStyles:{left:`${e}px`,top:`${t}px`},tooltipArrowStyles:{},place:r})))};var x="core-styles-module_tooltip__3vRRp",$="core-styles-module_fixed__pcSol",I="core-styles-module_arrow__cvMwQ",j="core-styles-module_noArrow__xock6",B="core-styles-module_clickable__ZuTTB",D="core-styles-module_show__Nt9eE",H={tooltip:"styles-module_tooltip__mnnfp",arrow:"styles-module_arrow__K0L3T",dark:"styles-module_dark__xNqje",light:"styles-module_light__Z6W-X",success:"styles-module_success__A2AKt",warning:"styles-module_warning__SCK0X",error:"styles-module_error__JvumD",info:"styles-module_info__BWdHW"};const q=({id:t,className:n,classNameArrow:l,variant:s="dark",anchorId:a,anchorSelect:d,place:u="top",offset:p=10,events:v=["hover"],openOnClick:y=!1,positionStrategy:h="absolute",middlewares:w,wrapper:b,delayShow:S=0,delayHide:_=0,float:g=!1,hidden:A=!1,noArrow:T=!1,clickable:L=!1,closeOnEsc:C=!1,closeOnScroll:q=!1,closeOnResize:z=!1,style:P,position:M,afterShow:W,afterHide:F,content:K,contentWrapperRef:U,isOpen:X,holdPositionOnRender:Y,setIsOpen:V,activeAnchor:Z,setActiveAnchor:G,border:J,opacity:Q,arrowColor:ee})=>{const te=i(null),re=i(null),oe=i(null),ne=i(null),[le,ie]=r(u),[ce,se]=r({}),[ae,de]=r({}),[ue,pe]=r(!1),[ve,me]=r(!1),fe=i(!1),ye=i(null),{anchorRefs:he,setActiveAnchor:we}=O(t),be=i(!1),[Se,Ee]=r([]),_e=i(!1),ge=y||v.includes("click");R((()=>(_e.current=!0,()=>{_e.current=!1})),[]),c((()=>{if(!ue){const e=setTimeout((()=>{me(!1)}),150);return()=>{clearTimeout(e)}}return()=>null}),[ue]);const Ae=e=>{_e.current&&(e&&me(!0),setTimeout((()=>{_e.current&&(null==V||V(e),void 0===X&&pe(e))}),10))};c((()=>{if(void 0===X)return()=>null;X&&me(!0);const e=setTimeout((()=>{pe(X)}),10);return()=>{clearTimeout(e)}}),[X]),c((()=>{ue!==fe.current&&(fe.current=ue,ue?null==W||W():null==F||F())}),[ue]);const Te=(e=_)=>{ne.current&&clearTimeout(ne.current),ne.current=setTimeout((()=>{be.current||Ae(!1)}),e)},Oe=e=>{var t;if(!e)return;const r=null!==(t=e.currentTarget)&&void 0!==t?t:e.target;if(!(null==r?void 0:r.isConnected))return G(null),void we({current:null});S?(oe.current&&clearTimeout(oe.current),oe.current=setTimeout((()=>{Ae(!0)}),S)):Ae(!0),G(r),we({current:r}),ne.current&&clearTimeout(ne.current)},Le=()=>{L?Te(_||100):_?Te():Ae(!1),oe.current&&clearTimeout(oe.current)},Re=({x:e,y:t})=>{k({place:u,offset:p,elementReference:{getBoundingClientRect:()=>({x:e,y:t,width:0,height:0,top:t,left:e,right:e,bottom:t})},tooltipReference:te.current,tooltipArrowReference:re.current,strategy:h,middlewares:w,border:J}).then((e=>{Object.keys(e.tooltipStyles).length&&se(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&de(e.tooltipArrowStyles),ie(e.place)}))},Ce=e=>{if(!e)return;const t=e,r={x:t.clientX,y:t.clientY};Re(r),ye.current=r},Ne=e=>{Oe(e),_&&Te()},ke=e=>{var t;[document.querySelector(`[id='${a}']`),...Se].some((t=>null==t?void 0:t.contains(e.target)))||(null===(t=te.current)||void 0===t?void 0:t.contains(e.target))||(Ae(!1),oe.current&&clearTimeout(oe.current))},xe=E(Oe,50,!0),$e=E(Le,50,!0),Ie=o((()=>{M?Re(M):g?ye.current&&Re(ye.current):(null==Z?void 0:Z.isConnected)&&k({place:u,offset:p,elementReference:Z,tooltipReference:te.current,tooltipArrowReference:re.current,strategy:h,middlewares:w,border:J}).then((e=>{_e.current&&(Object.keys(e.tooltipStyles).length&&se(e.tooltipStyles),Object.keys(e.tooltipArrowStyles).length&&de(e.tooltipArrowStyles),ie(e.place))}))}),[ue,Z,K,P,u,p,h,M,g]);c((()=>{var e,t;const r=new Set(he);Se.forEach((e=>{r.add({current:e})}));const o=document.querySelector(`[id='${a}']`);o&&r.add({current:o});const n=()=>{Ae(!1)},l=N(Z),i=N(te.current);q&&(window.addEventListener("scroll",n),null==l||l.addEventListener("scroll",n),null==i||i.addEventListener("scroll",n));let c=null;z?window.addEventListener("resize",n):Z&&te.current&&!Y&&(c=m(Z,te.current,Ie,{ancestorResize:!0,elementResize:!0,layoutShift:!0}));const s=e=>{"Escape"===e.key&&Ae(!1)};C&&window.addEventListener("keydown",s);const d=[];ge?(window.addEventListener("click",ke),d.push({event:"click",listener:Ne})):(d.push({event:"mouseenter",listener:xe},{event:"mouseleave",listener:$e},{event:"focus",listener:xe},{event:"blur",listener:$e}),g&&d.push({event:"mousemove",listener:Ce}));const u=()=>{be.current=!0},p=()=>{be.current=!1,Le()};return L&&!ge&&(null===(e=te.current)||void 0===e||e.addEventListener("mouseenter",u),null===(t=te.current)||void 0===t||t.addEventListener("mouseleave",p)),d.forEach((({event:e,listener:t})=>{r.forEach((r=>{var o;null===(o=r.current)||void 0===o||o.addEventListener(e,t)}))})),()=>{var e,t;q&&(window.removeEventListener("scroll",n),null==l||l.removeEventListener("scroll",n),null==i||i.removeEventListener("scroll",n)),z?window.removeEventListener("resize",n):null==c||c(),ge&&window.removeEventListener("click",ke),C&&window.removeEventListener("keydown",s),L&&!ge&&(null===(e=te.current)||void 0===e||e.removeEventListener("mouseenter",u),null===(t=te.current)||void 0===t||t.removeEventListener("mouseleave",p)),d.forEach((({event:e,listener:t})=>{r.forEach((r=>{var o;null===(o=r.current)||void 0===o||o.removeEventListener(e,t)}))}))}}),[Z,Ie,ve,he,Se,C,v]),c((()=>{let e=null!=d?d:"";!e&&t&&(e=`[data-tooltip-id='${t}']`);const r=new MutationObserver((r=>{const o=[],n=[];r.forEach((r=>{if("attributes"===r.type&&"data-tooltip-id"===r.attributeName){r.target.getAttribute("data-tooltip-id")===t&&o.push(r.target)}if("childList"===r.type){if(Z){const t=[...r.removedNodes].filter((e=>1===e.nodeType));e&&(n.push(...t.filter((t=>t.matches(e)))),n.push(...t.flatMap((t=>[...t.querySelectorAll(e)])))),t.some((e=>{var t;return!!(null===(t=null==e?void 0:e.contains)||void 0===t?void 0:t.call(e,Z))&&(me(!1),Ae(!1),G(null),oe.current&&clearTimeout(oe.current),ne.current&&clearTimeout(ne.current),!0)}))}if(e)try{const t=[...r.addedNodes].filter((e=>1===e.nodeType));o.push(...t.filter((t=>t.matches(e)))),o.push(...t.flatMap((t=>[...t.querySelectorAll(e)])))}catch(e){}}})),o.length&&Ee((e=>[...e.filter((e=>n.includes(e))),...o]))}));return r.observe(document.body,{childList:!0,subtree:!0,attributes:!0,attributeFilter:["data-tooltip-id"]}),()=>{r.disconnect()}}),[t,d,Z]),c((()=>{Ie()}),[Ie]),c((()=>{if(!(null==U?void 0:U.current))return()=>null;const e=new ResizeObserver((()=>{Ie()}));return e.observe(U.current),()=>{e.disconnect()}}),[K,null==U?void 0:U.current]),c((()=>{var e;const t=document.querySelector(`[id='${a}']`),r=[...Se,t];Z&&r.includes(Z)||G(null!==(e=Se[0])&&void 0!==e?e:t)}),[a,Se,Z]),c((()=>()=>{oe.current&&clearTimeout(oe.current),ne.current&&clearTimeout(ne.current)}),[]),c((()=>{let e=d;if(!e&&t&&(e=`[data-tooltip-id='${t}']`),e)try{const t=Array.from(document.querySelectorAll(e));Ee(t)}catch(e){Ee([])}}),[t,d]);const je=!A&&K&&ue&&Object.keys(ce).length>0;return ve||fe.current&&Y?e.createElement(b,{id:t,role:"tooltip",className:f("react-tooltip",x,H.tooltip,H[s],n,`react-tooltip__place-${le}`,{"react-tooltip__show":je,[D]:je,[$]:"fixed"===h,[B]:L}),style:{...P,...ce,opacity:void 0!==Q&&je?Q:void 0},ref:te},K,e.createElement(b,{className:f("react-tooltip-arrow",I,H.arrow,l,{[j]:T}),style:{...ae,background:ee?`linear-gradient(to right bottom, transparent 50%, ${ee} 50%)`:void 0},ref:re})):null},z=({content:t})=>e.createElement("span",{dangerouslySetInnerHTML:{__html:t}}),P=({id:t,anchorId:o,anchorSelect:n,content:l,html:s,render:a,className:d,classNameArrow:u,variant:p="dark",place:v="top",offset:m=10,wrapper:f="div",children:y=null,events:h=["hover"],openOnClick:w=!1,positionStrategy:b="absolute",middlewares:S,delayShow:E=0,delayHide:_=0,float:g=!1,hidden:A=!1,noArrow:T=!1,clickable:L=!1,closeOnEsc:R=!1,closeOnScroll:C=!1,closeOnResize:N=!1,style:k,position:x,isOpen:$,disableStyleInjection:I=!1,holdPositionOnRender:j,border:B,opacity:D,arrowColor:H,setIsOpen:P,afterShow:M,afterHide:W})=>{const[F,K]=r(l),[U,X]=r(s),[Y,V]=r(v),[Z,G]=r(p),[J,Q]=r(m),[ee,te]=r(E),[re,oe]=r(_),[ne,le]=r(g),[ie,ce]=r(A),[se,ae]=r(f),[de,ue]=r(h),[pe,ve]=r(b),[me,fe]=r(null),ye=i(I),{anchorRefs:he,activeAnchor:we}=O(t),be=e=>null==e?void 0:e.getAttributeNames().reduce(((t,r)=>{var o;if(r.startsWith("data-tooltip-")){t[r.replace(/^data-tooltip-/,"")]=null!==(o=null==e?void 0:e.getAttribute(r))&&void 0!==o?o:null}return t}),{}),Se=e=>{const t={place:e=>{var t;V(null!==(t=e)&&void 0!==t?t:v)},content:e=>{K(null!=e?e:l)},html:e=>{X(null!=e?e:s)},variant:e=>{var t;G(null!==(t=e)&&void 0!==t?t:p)},offset:e=>{Q(null===e?m:Number(e))},wrapper:e=>{var t;ae(null!==(t=e)&&void 0!==t?t:f)},events:e=>{const t=null==e?void 0:e.split(" ");ue(null!=t?t:h)},"position-strategy":e=>{var t;ve(null!==(t=e)&&void 0!==t?t:b)},"delay-show":e=>{te(null===e?E:Number(e))},"delay-hide":e=>{oe(null===e?_:Number(e))},float:e=>{le(null===e?g:"true"===e)},hidden:e=>{ce(null===e?A:"true"===e)}};Object.values(t).forEach((e=>e(null))),Object.entries(e).forEach((([e,r])=>{var o;null===(o=t[e])||void 0===o||o.call(t,r)}))};c((()=>{K(l)}),[l]),c((()=>{X(s)}),[s]),c((()=>{V(v)}),[v]),c((()=>{G(p)}),[p]),c((()=>{Q(m)}),[m]),c((()=>{te(E)}),[E]),c((()=>{oe(_)}),[_]),c((()=>{le(g)}),[g]),c((()=>{ce(A)}),[A]),c((()=>{ve(b)}),[b]),c((()=>{ye.current!==I&&console.warn("[react-tooltip] Do not change `disableStyleInjection` dynamically.")}),[I]),c((()=>{"undefined"!=typeof window&&window.dispatchEvent(new CustomEvent("react-tooltip-inject-styles",{detail:{disableCore:"core"===I,disableBase:I}}))}),[]),c((()=>{var e;const r=new Set(he);let l=n;if(!l&&t&&(l=`[data-tooltip-id='${t}']`),l)try{document.querySelectorAll(l).forEach((e=>{r.add({current:e})}))}catch(e){console.warn(`[react-tooltip] "${l}" is not a valid CSS selector`)}const i=document.querySelector(`[id='${o}']`);if(i&&r.add({current:i}),!r.size)return()=>null;const c=null!==(e=null!=me?me:i)&&void 0!==e?e:we.current,s=new MutationObserver((e=>{e.forEach((e=>{var t;if(!c||"attributes"!==e.type||!(null===(t=e.attributeName)||void 0===t?void 0:t.startsWith("data-tooltip-")))return;const r=be(c);Se(r)}))})),a={attributes:!0,childList:!1,subtree:!1};if(c){const e=be(c);Se(e),s.observe(c,a)}return()=>{s.disconnect()}}),[he,we,me,o,n]),c((()=>{(null==k?void 0:k.border)&&console.warn("[react-tooltip] Do not set `style.border`. Use `border` prop instead."),B&&!CSS.supports("border",`${B}`)&&console.warn(`[react-tooltip] "${B}" is not a valid \`border\`.`),(null==k?void 0:k.opacity)&&console.warn("[react-tooltip] Do not set `style.opacity`. Use `opacity` prop instead."),D&&!CSS.supports("opacity",`${D}`)&&console.warn(`[react-tooltip] "${D}" is not a valid \`opacity\`.`)}),[]);let Ee=y;const _e=i(null);if(a){const t=a({content:null!=F?F:null,activeAnchor:me});Ee=t?e.createElement("div",{ref:_e,className:"react-tooltip-content-wrapper"},t):null}else F&&(Ee=F);U&&(Ee=e.createElement(z,{content:U}));const ge={id:t,anchorId:o,anchorSelect:n,className:d,classNameArrow:u,content:Ee,contentWrapperRef:_e,place:Y,variant:Z,offset:J,wrapper:se,events:de,openOnClick:w,positionStrategy:pe,middlewares:S,delayShow:ee,delayHide:re,float:ne,hidden:ie,noArrow:T,clickable:L,closeOnEsc:R,closeOnScroll:C,closeOnResize:N,style:k,position:x,isOpen:$,holdPositionOnRender:j,border:B,opacity:D,arrowColor:H,setIsOpen:P,afterShow:M,afterHide:W,activeAnchor:me,setActiveAnchor:e=>fe(e)};return e.createElement(q,{...ge})};"undefined"!=typeof window&&window.addEventListener("react-tooltip-inject-styles",(e=>{e.detail.disableCore||b({css:`:root{--rt-color-white:#fff;--rt-color-dark:#222;--rt-color-success:#8dc572;--rt-color-error:#be6464;--rt-color-warning:#f0ad4e;--rt-color-info:#337ab7;--rt-opacity:0.9}.core-styles-module_tooltip__3vRRp{visibility:hidden;position:absolute;top:0;left:0;pointer-events:none;opacity:0;transition:opacity 0.3s ease-out;will-change:opacity,visibility}.core-styles-module_fixed__pcSol{position:fixed}.core-styles-module_arrow__cvMwQ{position:absolute;background:inherit}.core-styles-module_noArrow__xock6{display:none}.core-styles-module_clickable__ZuTTB{pointer-events:auto}.core-styles-module_show__Nt9eE{visibility:visible;opacity:var(--rt-opacity)}`,type:"core"}),e.detail.disableBase||b({css:`
.styles-module_tooltip__mnnfp{padding:8px 16px;border-radius:3px;font-size:90%;width:max-content}.styles-module_arrow__K0L3T{width:8px;height:8px}[class*='react-tooltip__place-top']>.styles-module_arrow__K0L3T{transform:rotate(45deg)}[class*='react-tooltip__place-right']>.styles-module_arrow__K0L3T{transform:rotate(135deg)}[class*='react-tooltip__place-bottom']>.styles-module_arrow__K0L3T{transform:rotate(225deg)}[class*='react-tooltip__place-left']>.styles-module_arrow__K0L3T{transform:rotate(315deg)}.styles-module_dark__xNqje{background:var(--rt-color-dark);color:var(--rt-color-white)}.styles-module_light__Z6W-X{background-color:var(--rt-color-white);color:var(--rt-color-dark)}.styles-module_success__A2AKt{background-color:var(--rt-color-success);color:var(--rt-color-white)}.styles-module_warning__SCK0X{background-color:var(--rt-color-warning);color:var(--rt-color-white)}.styles-module_error__JvumD{background-color:var(--rt-color-error);color:var(--rt-color-white)}.styles-module_info__BWdHW{background-color:var(--rt-color-info);color:var(--rt-color-white)}`,type:"base"})}));export{P as Tooltip,T as TooltipProvider,L as TooltipWrapper,S as removeStyle};
